const uuidv4 = require('uuid/v4');
const system = require("../../../system");
const ServiceBase = require("../../sve.base");
const settings = require("../../../../config/settings");
class NeedinfoService extends ServiceBase {
  constructor() {
    super("dbneed", ServiceBase.getDaoName(NeedinfoService));
    this.execlient = system.getObject("util.execClient");
  }
  async getItemByNeedNo(pobj){
    
  }
  async needinfo2fq(pobj) {
    pobj.actionBody.needNo = await this.getBusUid("n");
    pobj.actionBody.uapp_id = pobj.appInfo.id;
    var needinfo = await this.dao.create(pobj.actionBody);
    var pobj = {
      "idempotentId": needinfo.needNo,
      "idempotentSource": needinfo.chanceType_code,
      "idempotentSourceName": pobj.appInfo.app_name + "_" + pobj.actionBody.chanceTypeName,
      "phone": needinfo.publishMobile,
      "remark": needinfo.notes,
      "customerName": needinfo.publishName
    };

    var rc = system.getObject("util.aliyunClient");
    var rtn = await rc.post("https://yunfuapi.gongsibao.com/crm/opportunity/submit", pobj);
    console.log(rtn)
    return system.getResultSuccess();
    // var opResultstr = await this.execlient.execPost(pobj, "https://yunfuapi-dev.gongsibao.com/crm/opportunity/submit");
    // opResult = JSON.parse(opResultstr.stdout)
    // if (opResultstr) {
    //   return system.getResultSuccess();
    // }
  }

  // intentionBizId
  // mobile
  // userName
  // description
  // area
  // type
  // ext
  async createicneedinfo(pobj, actionBody) {
    var needNo = await this.getBusUid("n");
    if (actionBody.intentionBizId) {
      return system.getResult(null, "intentionBizId不能为空");
    }
    if (actionBody.mobile) {
      return system.getResult(null, "mobile不能为空");
    }
    if (actionBody.type) {
      return system.getResult(null, "type不能为空");
    }
    var nobj = {
      uapp_id: pobj.appInfo.uapp_id,
      channelNeedNo: actionBody.intentionBizId,
      needNo: needNo,
      channelUserId: pobj.userInfo.channel_userid,
      publishName: actionBody.userName,
      publishContent: actionBody.description,
      publishMobile: actionBody.mobile,
      city: actionBody.area,
      disposeNotes: actionBody.ext,
      channelTypeCode: actionBody.type
    }
    return await this.dao.create(nobj);
  }

  async solutionClose(pobj) {
    if (actionBody.intentionBizId) {
      return system.getResult(null, "intentionBizId不能为空");
    }
    var needinfo = await this.findOne({ channelNeedNo: actionBody.intentionBizId });
    needinfo.status = "ygb";
    var self=this;
    return await self.db.transaction(async function (t) {
      await self.update(needinfo,t);
      var needsolutioninfo = await self.needsolutionDao.findOne({ channelNeedNo: pobj.actionBody.intentionBizId }, t)
      needsolutioninfo.status = "yzf";
      await self.needsolutionDao.update(needsolutioninfo, t);
      // await 
    })
  }

  async flowinfo(obj) {

  }

}
module.exports = NeedinfoService;

// var a=new NeedinfoService();
// a.needinfo2fq();